/* 
 * malloctest.c
 * 
 * Reto Baettig ( baettig@scs.ch )
 * 5-23-00
 * 
 */

#include <pthread.h>                                                            
#include <stdlib.h>                                                              
#include <errno.h>

#define NUM_THREADS 	20		
#define BUFSIZE (1024*1024)

pthread_mutex_t	mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t malloc_mutex = PTHREAD_MUTEX_INITIALIZER;

int	  numthreads = 0;
long long nummallocs = 0;
long long numerrs = 0;

#ifdef MUTEX
void *my_malloc(size_t size)
{
	void *addr;
	pthread_mutex_lock(&malloc_mutex);
	addr = malloc(size);
	pthread_mutex_unlock(&malloc_mutex);
	return(addr);
}

void my_free(void *ptr)
{
	pthread_mutex_lock(&malloc_mutex);
	free(ptr);
	pthread_mutex_unlock(&malloc_mutex);
}
#else
void *my_malloc(size_t size)
{
	return(malloc(size));
}

void my_free(void *ptr)
{
	free(ptr);
}
#endif
                                                                                
void *foo()                                                         
{                                                                               
	char *buf;
	
	for (;;) 
	{
		if (buf = my_malloc(BUFSIZE))
		{
			pthread_mutex_lock(&mutex);
			nummallocs++;
			pthread_mutex_unlock(&mutex);
			my_free(buf);
		} else
		{
			pthread_mutex_lock(&mutex);
			numerrs++;
			pthread_mutex_unlock(&mutex);
		}
	}
}                                                                               

													                                                                                
int main(int argc, char *argv[])                                                
{                                                                               
	pthread_t	threads[NUM_THREADS];                                                          
	pthread_attr_t	attr;                                                    
	int		i;                                                                
	long long       num,err;
	

	pthread_mutex_init(&mutex,NULL);
#ifdef MUTEX
	pthread_mutex_init(&malloc_mutex,NULL);
#endif
	pthread_attr_init(&attr);

	for (i=0; i < NUM_THREADS; i++) {
		if (pthread_create(&threads[i], &attr, foo, NULL) < 0) {
			perror("pthread_create");
			exit(1);
		}
		pthread_mutex_lock(&mutex);
		numthreads++;
		pthread_mutex_unlock(&mutex);
	}


	while (1) {
		sleep(1);
		pthread_mutex_lock(&mutex);
		num = nummallocs;
		err = numerrs;
		pthread_mutex_unlock(&mutex);
		printf("Malloc/Free : %Ld times, %Ld errors\n",num,err);
	}
	return 0;
}
